##############################################################################
# This is an addon for "sitebot-glftpd.tcl by DaRKHeaRT(rhett@lotus-net.ch)" #
##############################################################################
# ADDON: Script Updater v0.5                                                 #
# CODER: DaRKHeaRT                                                           #
# REQS : http.tcl v1.0 must be in scripts dir                                #
# NOTE : if your shell uses proxy server then look below to setup proxy      #
#        settings!                                                           #
#                                                                            #
# DESC : type .supdate for help                                              #
#                                                                            #
#        The reason i did this script as an addon (cool new feature eh :P)   #
#        is it requires http.tcl and i know some people have problems with   #
#        getting this tcl to work.                                           #
#                                                                            #
#        if the web page is down when you try and run this command it may    #
#        stall your bot although its most likely that the transfer will just #
#        timeout.. the web page should be up always thou :)                  #
#                                                                            #
# INSTALL: put this script and http.tcl in your eggdrop scripts dir... no    #
#          changes to conf file required :)                                  #
#                                                                            #
# Big thanks to H-o-e who helped me with http stuff in this script. cheers!  #
#                                                                            #
##############################################################################

# start of configurable section. - only set if you need to use proxy server.

set proxy(enabled) "0";             # 1 = yes 0 = no
set proxy(host) "myproxy.isp.com";  # Proxy Host
set proxy(port) "8080";             # Proxy Port

# end of configurable section.

source scripts/http.tcl
set www "http://glftpd.deepwell.com/~rhett/"

bind dcc C ${dcc_prefix}update dcc_update

proc dcc_update {hand idx arg} {
 global configversion dcc_prefix proxy www
 set cmd [lindex $arg 0]
 switch -exact -- $cmd {
      "tarball" {
         putlog "#$hand# connecting to webpage... attempting to download sitebot tarball"
         if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
         set url "${www}version.txt" ; set tok [http_get $url] ; upvar #0 $tok state ; set currentversion [lindex $state(body) 0]
         set url "${www}sitebot${currentversion}.tar.gz"
         set out [open scripts/sitebot${currentversion} w] ; set tok [http_get $url -channel $out] ; close $out
         putdcc $idx "sitebot${currentversion}.tar.gz Successfully Downloaded"
    } "deladdon" {
         set file [lindex $arg 1]
         if { $file == "" } {putdcc $idx "Usage: .${dcc_prefix}update deladdon <addon_name>" ; return 0 }
         putlog "#$hand# request to remove addon: $arg"
         if {![file exists scripts/sitebot-addon-${file}.tcl]} { putdcc $idx "scripts/sitebot-addon-${file}.tcl not found." ; return 0 }
         set result [exec rm scripts/sitebot-addon-${file}.tcl]
         putdcc $idx "sitebot-addon-${file}.tcl removed. Please type .rehash for changes to take effect"
    } "addonlist" {
         putlog "#$hand# connecting to webpage... looking up addons list.."
         if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
         set url "${www}addons/list.txt"
         set tok [http_get $url] ; upvar #0 $tok state
         set counter "-1" ; foreach body [array names state] { set counter [expr $counter + 1] ; set file [lindex $state(body) $counter] ; putdcc $idx "$file" }
    } "getaddon" {
         set file [lindex $arg 1]
         if { $file == "" } {putdcc $idx "Usage: .${dcc_prefix}update getaddon <addon_name>" ; return 0 }
         putlog "#$hand# connecting to webpage... attempting to download the addon : $file"
         set url "${www}addons/sitebot-addon-${file}.tcl"
         set out [open scripts/sitebot-addon-${file}.tcl w] ; set tok [http_get $url -channel $out] ; close $out
         putlog "Download of $file complete... type .rehash to load it."
    } "checkversion" {
         putlog "#$hand# checking for new versions of sitebot tcl"
         if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
         set url "${www}version.txt"
         set tok [http_get $url] ; upvar #0 $tok state
         set currentversion [lindex $state(body) 0]

         if {$configversion < $currentversion} { putdcc $idx "Your Version: $configversion Latest Version: $currentversion" ; putdcc $idx "Seems your outofdate! type .${dcc_prefix}updateme to get latest version" }
         if {$configversion == $currentversion} { putdcc $idx "Your Version: $configversion Latest Version: $currentversion" ; putdcc $idx "Versions Match! Seems your uptodate!" }
         if {$configversion > $currentversion} { putdcc $idx "Your Version: $configversion Latest Version: $currentversion" ; putdcc $idx "If your seeing this i mustnt be keeping my web page uptodate" ; putdcc $idx "or someone has changed the versions or someone else is maintaining" ; putdcc $idx "my script now! who knows?" }
     } "install" {
         putlog "#$hand# checking to makesure your running an old version."
         if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
         set url "${www}version.txt"
         set tok [http_get $url] ; upvar #0 $tok state
         set currentversion [lindex $state(body) 0]

         if {$configversion < $currentversion} { putdcc $idx "Your Version: $configversion Latest Version: $currentversion" }
         if {$configversion == $currentversion} { putdcc $idx "Your Version: $configversion Latest Version: $currentversion" ; putdcc $idx "Versions Match! Seems your already uptodate! ... Exiting Update" ; return 0 }
         if {$configversion > $currentversion} { putdcc $idx "Your Version: $configversion Latest Version: $currentversion" ; putdcc $idx "If your seeing this i mustnt be keeping my web page uptodate" ; putdcc $idx "or someone has changed the versions or someone else is maintaining" ; putdcc $idx "my script now! who knows? ... Exiting Update" ; return 0 }

         putlog "#$hand# connecting to webpage... attempting to upgrade.. fingers crossed :)"
         if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
         set url "${www}list.txt"
         set tok [http_get $url] ; upvar #0 $tok state

         set counter "-1"

         foreach body [array names state] {
                 set counter [expr $counter + 1] ; set file [lindex $state(body) $counter] ; putdcc $idx "Downloading : $file"
                 set url "${www}$file"
                 set out [open scripts/$file w] ; set tok [http_get $url -channel $out] ; close $out
         }

         putdcc $idx "Upgrade Complete.. Type .rehash for changes to take effect... You may need to .die bot and restart from shell."
     }

    default {putdcc $idx "${dcc_prefix}update help.............."
             putdcc $idx "${dcc_prefix}update install          - downloads and installs latest sitebot-glftpd tcl"
             putdcc $idx "${dcc_prefix}update tarball          - downloads latest sitebot tar.gz to your scripts dir"
             putdcc $idx "${dcc_prefix}update checkversion     - checks to see if you have the latest version"
             putdcc $idx "${dcc_prefix}update addonlist        - lists available addons"
             putdcc $idx "${dcc_prefix}update getaddon <file>  - download and install an addon."
             putdcc $idx "${dcc_prefix}update deladdon <file>  - Delete an addon from your scripts dir."
    }
 }
}

sitebot:addversion "Script Updater v0.5"
